unit Win2KButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TWin2KButton = class(TBitBtn)
  private
    { Private-Deklarationen}
   MouseIn : Boolean;
   PROCEDURE MouseEnter(VAR Message : TMessage); message CM_MOUSEENTER;
   PROCEDURE MouseLeave(VAR Message : TMessage); message CM_MOUSELEAVE;
   PROCEDURE DrawBorder;
   PROCEDURE SetFocus(VAR Message : TWMSetFocus); message WM_SETFOCUS;
   PROCEDURE KillFocus(VAR Message : TWMKillFocus); message WM_KILLFOCUS;
   PROCEDURE Paint(VAR Message : TMessage); message WM_PAINT;
  protected
    { Protected-Deklarationen}
  public
    { Public-Deklarationen}
   CONSTRUCTOR Create(AOwner : TComponent);
  published
    { Published-Deklarationen }
  end;

procedure Register;

implementation

CONSTRUCTOR TWin2KButton.Create(AOwner : TComponent);
BEGIN
 inherited;
 MouseIn := False;
 DrawBorder;
END;

PROCEDURE TWin2KButton.DrawBorder;
VAR DC : HDC;
    R : TRect;
    BtnShadowPen, BtnFacePen, BtnTextPen : HPEN;
    X,Y : Integer;
BEGIN
 //T := 0;
 DC := GetWindowDC(Handle);
 TRY
  GetWindowRect(Handle, R);
  OffsetRect(R, -R.Left, -R.Top);
  BtnShadowPen := CreatePen(PS_SOLID,1,clGray);
  BtnTextPen := CreatePen(PS_SOLID,1,clBlack);
  BtnFacePen := CreatePen(PS_SOLID,1,clSilver);
  IF MouseIn AND NOT Focused THEN
    BEGIN
     SelectObject(DC, BtnShadowPen);
     MoveToEx(DC, R.Right-2, R.Top, NIL);
     X := R.Right-2; Y := R.Bottom-1;
     LineTo(DC, X, Y);
     MoveToEx(DC, R.Left, R.Bottom-2, NIL);
     X := R.Right-2; Y := R.Bottom-2;
     LineTo(DC, X, Y);

     SelectObject(DC, BtnTextPen);
     MoveToEx(DC, R.Right-1, R.Top, NIL);
     X := R.Right-1; Y := R.Bottom;
     LineTo(DC, X, Y);
     MoveToEx(DC, R.Left, R.Bottom-1, NIL);
     X := R.Right-1; Y := R.Bottom-1;
     LineTo(DC, X, Y);
    END;
  IF NOT MouseIn AND NOT Focused THEN
    BEGIN
     SelectObject(DC, BtnShadowPen);
     MoveToEx(DC,R.Left,R.Bottom-1,NIL);
     X := R.Right-1; Y := R.Bottom-1;
     LineTo(DC, X, Y);
     MoveToEx(DC,R.Right-1,R.Top,NIL);
     X := R.Right-1; Y := R.Bottom;
     LineTo(DC, X, Y);

     SelectObject(DC, BtnFacePen);
     MoveToEx(DC, R.Right-2, R.Top, NIL);
     X := R.Right-2; Y := R.Bottom-1;
     LineTo(DC, X, Y);
     MoveToEx(DC, R.Left, R.Bottom-2, NIL);
     X := R.Right-2; Y := R.Bottom-2;
     LineTo(DC, X, Y);
    END
  FINALLY
    DeleteObject(BtnFacePen);
    DeleteObject(BtnTextPen);
    DeleteObject(BtnShadowPen);
    ReleaseDC (Handle, DC);
  END;
END;

PROCEDURE TWin2KButton.MouseEnter;
BEGIN
 inherited;
 MouseIn := TRUE;
 DrawBorder;
END;

PROCEDURE TWin2KButton.MouseLeave;
BEGIN
 inherited;
 MouseIn := FALSE;
 DrawBorder;
END;

PROCEDURE TWin2KButton.Paint;
BEGIN
 inherited;
 DrawBorder;
END;

PROCEDURE TWin2KButton.SetFocus;
BEGIN
 inherited;
 DrawBorder;
END;

PROCEDURE TWin2KButton.KillFocus;
BEGIN
 inherited;
 DrawBorder;
END;

procedure Register;
begin
  RegisterComponents('Freeware', [TWin2KButton]);
end;

end.
